# This is the suffix that will be added to the version number
# instead of the artifacts added to the MEAD repository:
%global meadrel .Alpha10

# This is the location for the files of the repolib sub package
# containg artifacts to be added to the MEAD repository:
%global meaddir %{_javadir}/repository.jboss.com/maven2-brew/org/ovirt/engine/sdk/sdk/%{version}%{meadrel}

Name: java-ovirt-engine-sdk4
Version: 4.0.0
Release: 0.0%{meadrel}%{?dist}
Summary: Java SDK for version 4 of the oVirt Engine API
Group: Development/Libraries
License: ASL 2.0
URL: http://ovirt.org/wiki/SDK

# Most of the source code of the SDK is generated automatically, but
# that isn't part of this build process, so in order to update the
# sources of this RPM you need to clone the upstream repository, run the
# generator, and use the generated tarball:
#
# git clone git://gerrit.ovirt.org/ovirt-engine-sdk-java
# cd ovirt-engine-sdk-java
# ./automation/build-artifacts.sh
# cp ./packaging/ovirt-engine-sdk-java-4.0.0.tar.gz ...
Source0: ovirt-engine-sdk-java-%{version}%{meadrel}.tar.gz

# This Ant build file is part of the downstream process, for
# environments where Maven isn't available:
Source1: build.xml

BuildArch: noarch

BuildRequires: ant
BuildRequires: java-1.8.0-openjdk-devel
BuildRequires: mvn(com.sun.xml.txw2:txw2)
BuildRequires: mvn(org.apache.httpcomponents:httpclient)
BuildRequires: mvn(org.apache.httpcomponents:httpcore)
BuildRequires: mvn(org.codehaus.jackson:jackson-core-asl)
BuildRequires: mvn(org.codehaus.jackson:jackson-mapper-asl)
BuildRequires: mvn(org.slf4j:slf4j-api)

Requires: mvn(com.sun.xml.txw2:txw2)
Requires: mvn(org.apache.httpcomponents:httpclient)
Requires: mvn(org.apache.httpcomponents:httpcore)
Requires: mvn(org.codehaus.jackson:jackson-core-asl)
Requires: mvn(org.codehaus.jackson:jackson-mapper-asl)
Requires: mvn(org.slf4j:slf4j-api)

%description
This package contains the Java SDK for version 4 of the oVirt Engine
API.

%package repolib
Summary: %{name} Maven repository

%description repolib
%{name} Maven repository

%prep

# Unpack the source:
%setup -q -n ovirt-engine-sdk-java-%{version}%{meadrel}

%build

# Make sure that Java 8 will be used regardless of other installed
# versions:
JAVA_HOME=$(dirname $(rpm -ql java-1.8.0-openjdk-devel | grep '/bin$'))
PATH="${JAVA_HOME}/bin:${PATH}"
export JAVA_HOME PATH

# Replace the version number in the POM file with the version number
# of the RPM followed by the MEAD release number:
sed -i \
  '0,/<version>.*<\/version>/s/<version>.*<\/version>/<version>%{version}%{meadrel}<\/version>/' \
  pom.xml

# Copy the Ant build script to the directory containing the source of
# the SDK:
cp %{SOURCE1} build.xml

# Populate the lib directory with symlinks to the required dependencies that
# will be used to create the compiler classpath:
mkdir lib
while read jar
do
  ln -s %{_javadir}/${jar}.jar lib
done <<.
httpcomponents/httpclient
httpcomponents/httpcore
jackson/jackson-core-asl
jackson/jackson-mapper-asl
slf4j/api
txw2
.

# Perform the build using Ant:
java -jar %{_javadir}/ant-launcher.jar -f build.xml

%install

# Install the files for the main package:
install -d -m 755 %{buildroot}%{_javadir}/%{name}
install -pm 644 target/%{name}.jar %{buildroot}%{_javadir}/%{name}/%{name}.jar

# Install the files for the repolib package:
mkdir -p %{buildroot}%{meaddir}
cp target/%{name}.jar %{buildroot}%{meaddir}/sdk-%{version}%{meadrel}.jar
cp pom.xml %{buildroot}%{meaddir}/sdk-%{version}%{meadrel}.pom

%files
%doc README.adoc
%license LICENSE.txt
%{_javadir}/%{name}

%files repolib
%{_javadir}/repository.jboss.com

%changelog
* Wed Apr 13 2016 Juan Hernandez <juan.hernandez@redhat.com> - 4.0.0-0.0
- Initial packaging.
